<template>
  <div style="min-height: 90vh">
    <GToolbar
      :i18n="i18n"
      :add-btn-hint="i18nBase + `.add`"
      @addElement="add"
    />
    <div v-if="value && value.statement.length">
      <GCollapsibleCard
        v-for="(item, index) in value.statement"
        ref="collapsibleCard"
        :key="index"
        class="mt-4"
        :title="`${$t(`${i18nBase}.item`)} ${index + 1}`"
        wiki-entry="statement"
        border
        @move-up="moveUp(index)"
        @move-down="moveDown(index)"
        @remove="remove(index)"
      >
        <template #card-title-append>
          <GDropDownMenu
            i18n="form.addElement"
            :available-elements="availableElements(item, index)"
            icon="add"
            :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
            @addElement="addElement(item, index)"
          />
        </template>
        <StatementMetaData
          ref="statement"
          v-model="value.statement[index]"
          not-in-dialog
          :card="false"
        />
      </GCollapsibleCard>
    </div>
    <v-alert v-else type="info" icon="info" class="mt-4">
      {{ $t(`${i18nBase}.empty`) }}
    </v-alert>
  </div>
</template>

<script>
import {
  StatementMetaDataType,
  StatementListType,
  RichContentType,
  DataType,
  DCCXMLBoolean,
  DCCXMLElement,
} from "@d-ptb/dcc-js";
import { DCCXMLList } from "@d-ptb/dcc-js/lib/DCC";
import GCollapsibleCard from "../App/Common/GCollapsibleCard";
import StatementMetaData from "./Common/StatementMetaData";
import { insertIf, removeFromArray, swap } from "~/assets/util/general";
import GToolbar from "~/components/App/Common/GToolbar.vue";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";

export default {
  name: "StatementListExtensive",
  components: {
    GDropDownMenu,
    GToolbar,
    StatementMetaData,
    GCollapsibleCard,
  },
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.common.statementListType",
    },
    i18n: String,
    level: String,
  },
  methods: {
    availableElements(statement, index) {
      return [
        "description",
        "declaration",
        "valid",
        "validXMLList",
        "conformity",
        "conformityXMLList",
        "quantities",
      ]
        .filter((x) => !this.blacklist(statement).includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.statementList.${x}.title`),
            value: x,
            addElement: () => this.addElement(x, statement, index),
          };
        });
    },
    blacklist(statement) {
      return [
        ...insertIf(statement.description, "description"),
        ...insertIf(statement.declaration, "declaration"),
        ...insertIf(statement.valid, "valid", "validXMLList"),
        ...insertIf(statement.validXMLList, "valid", "validXMLList"),
        ...insertIf(statement.conformity, "conformity", "conformityXMLList"),
        ...insertIf(
          statement.conformityXMLList,
          "conformity",
          "conformityXMLList"
        ),
        ...insertIf(statement.data && statement.data.quantity, "quantities"),
      ];
    },
    addElement(element, statement, index) {
      switch (element) {
        case "description":
          this.$set(statement, "description", new RichContentType());
          break;
        case "declaration":
          this.$set(statement, "declaration", new RichContentType());
          break;
        case "valid":
          this.$set(statement, "valid", new DCCXMLBoolean());
          break;
        case "validXMLList":
          this.$set(statement, "validXMLList", new DCCXMLList());
          break;
        case "conformity":
          this.$set(statement, "conformity", new DCCXMLElement());
          break;
        case "conformityXMLList":
          this.$set(statement, "conformityXMLList", new DCCXMLList());
          break;
        case "quantities":
          this.$set(
            statement,
            "data",
            new DataType({
              quantity: [],
            })
          );
          break;
      }
      this.$nextTick(() => {
        this.$vuetify.goTo(this.$refs.statement[index].$refs[element]);
      });
    },
    async add() {
      // check if StatementListType exists
      if (!this.value) {
        // create new StatementListType
        this.$set(
          this.$global.dccDocument.digitalCalibrationCertificate
            .administrativeData,
          "statements",
          new StatementListType()
        );
        await this.$nextTick();
      }

      // add new statement to existing StatementListType
      this.value.statement.push(new StatementMetaDataType());

      // scroll to new element
      this.$nextTick(() => {
        this.$vuetify.goTo(
          this.$refs.collapsibleCard[this.$refs.collapsibleCard.length - 1]
        );
      });
    },
    moveUp(index) {
      if (index > 0) {
        swap(this.value.statement, index, index - 1);
      }
    },
    moveDown(index) {
      if (index < this.value.statement.length - 1) {
        swap(this.value.statement, index, index + 1);
      }
    },
    remove(index) {
      confirm(this.$t(`${this.i18nBase}.confirmRemove`)) &&
        removeFromArray(this.value.statement, this.value.statement[index]);
      if (!this.value.statement.length) {
        this.$delete(
          this.$global.dccDocument.digitalCalibrationCertificate
            .administrativeData,
          "statements"
        );
      }
    },
  },
};
</script>
